//Global variables
var auto_shutdown_bShutdown;
var auto_shutdown_iNumberOfADownload;
var auto_shutdown_is_listener_already_installed=false;
var auto_shutdown_is_idle_already_installed=false;

var idleService = Components.classes["@mozilla.org/widget/idleservice;1"]
                            .getService(Components.interfaces.nsIIdleService);
var prefs = Components.classes["@mozilla.org/preferences-service;1"]
					  .getService(Components.interfaces.nsIPrefService).getBranch("InBasic.ShutDown.");

// idle observer
var idleObserver = {
  observe: function(subject, topic, data) {
	var dlmgr = Components.classes['@mozilla.org/download-manager;1']
						  .getService(Components.interfaces.nsIDownloadManager);    //**** Get Download file object

	if(dlmgr.activeDownloadCount==0 && topic=="idle"){
		var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
						   .getService(Components.interfaces.nsIWindowWatcher);
		// set command type which should be executed
		var array = Components.classes["@mozilla.org/array;1"]
							  .createInstance(Components.interfaces.nsIMutableArray);
		var variant = Components.classes["@mozilla.org/variant;1"]
								.createInstance(Components.interfaces.nsIWritableVariant);
		variant.setFromVariant(1);  //command type is idle
		array.appendElement(variant, false);				   
				   
		var win = ww.openWindow(null, "chrome://inbshutdown/content/Shutdown.xul",
						        "Shutdown :: InBasic", "chrome,centerscreen, resizable=no", array);
	}
  }
};

function auto_shutdown_component() {
    this.wrappedJSObject = this;
}

auto_shutdown_component.prototype = {
  classID: Components.ID("{CED48986-935D-11DC-866B-6A9056D89593}"), 
  contractID: "@InBasic.org/AutoShutdown/component;1",
  classDescription: "InBasic Auto Shutdown Component",

  QueryInterface: function(aIID) {
    if(!aIID.equals(CI.nsISupports) && !aIID.equals(CI.nsIObserver) && !aIID.equals(CI.nsISupportsWeakReference)) // you can claim you implement more interfaces here
      throw CR.NS_ERROR_NO_INTERFACE;
    return this;
  },
  
  observe: function(aSubject, aTopic, aData) {

    switch(aTopic) {
      case "xpcom-startup":
		//Restart Shutdown
		auto_shutdown_bShutdown = false;
		auto_shutdown_iNumberOfADownload = 0;		 
        break;
    default:
		throw Components.Exception("Unknown topic: " + aTopic);
    }
  },
  
  onLoad: function() {
	if(!auto_shutdown_is_listener_already_installed){
		this.dlMgr = Components.classes["@mozilla.org/download-manager;1"]
	                          .getService(Components.interfaces.nsIDownloadManager);        
		this.dlMgr.addListener(sh_download_listener);
		auto_shutdown_is_listener_already_installed=true;		
	}
  },
  
  activateIDETest : function(){
	var dlmgr = Components.classes['@mozilla.org/download-manager;1']
						  .getService(Components.interfaces.nsIDownloadManager);    //**** Get Download file object
	if(auto_shutdown_bShutdown && prefs.getBoolPref("IDETest")){
		idleService.addIdleObserver(idleObserver, prefs.getCharPref("IDEDelay")); // per sec
		auto_shutdown_is_idle_already_installed=true;
	}
  },
  
  deactivateIDE : function(){
	if(auto_shutdown_is_idle_already_installed){
		idleService.removeIdleObserver(idleObserver, prefs.getCharPref("IDEDelay"));
		auto_shutdown_is_idle_already_installed=false;
	}
  },
  
  rbShutdown : function(){
	return auto_shutdown_bShutdown;
  },
  
  wbShutdown : function(sData){
	auto_shutdown_bShutdown = sData;
  }, 
  
  iNumberOfADownload : function(){
	return auto_shutdown_iNumberOfADownload;
  }
};

var sh_download_listener = {
	onProgressChange : function(webProgress,request,curSelfProgres,maxSelfProgress,curTotalProgres,maxTotalProgress,download){
	}, 
	onSecurityChange : function(webProgress,request,state,download){
	}, 
	onStateChange : function(webProgress,request,stateFlags,status,download){
	},
	onDownloadStateChange : function(aState,aDownload){
		//update download counter
		auto_shutdown_iNumberOfADownload = SetDownloadCount();
		switch(aDownload.state) {
			case Components.interfaces.nsIDownloadManager.DOWNLOAD_FINISHED:
			case Components.interfaces.nsIDownloadManager.DOWNLOAD_FAILED:
			case Components.interfaces.nsIDownloadManager.DOWNLOAD_CANCELED:		
				//play sound for down
				var sound = Components.classes["@mozilla.org/sound;1"] 
					.createInstance(Components.interfaces.nsISound); 
				var uri = Components.classes['@mozilla.org/network/standard-url;1'] 
					.createInstance(Components.interfaces.nsIURI); 
				uri.spec = "chrome://inbshutdown/skin/sounds/done.wav";
				
				var timer = Components.classes["@mozilla.org/timer;1"]
					.createInstance(Components.interfaces.nsITimer);
				var dlmgr = Components.classes['@mozilla.org/download-manager;1']
									  .getService(Components.interfaces.nsIDownloadManager);    //**** Get Download file object
				var PlaySound = { notify: function(timer){sound.play(uri);} }; 
				
				if(prefs.getCharPref("sndMode")=='0') 
					timer.initWithCallback(PlaySound, 1000 , Components.interfaces.nsITimer.TYPE_ONE_SHOT);
				
				//Play sound if all finished
				if(prefs.getCharPref("sndMode")=='1' && dlmgr.activeDownloadCount==0)
					timer.initWithCallback(PlaySound, 1000 , Components.interfaces.nsITimer.TYPE_ONE_SHOT);
				//show shutdown window if needed
				if(auto_shutdown_bShutdown && dlmgr.activeDownloadCount==0){
					//Open Window
					var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);

					var callback = {
						notify: function(timer) 
						{
							if(dlmgr.activeDownloadCount==0)
							{
								var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
												   .getService(Components.interfaces.nsIWindowWatcher);
								// set command type which should be executed
								var array = Components.classes["@mozilla.org/array;1"]
													  .createInstance(Components.interfaces.nsIMutableArray);
								var variant = Components.classes["@mozilla.org/variant;1"]
														.createInstance(Components.interfaces.nsIWritableVariant);
								variant.setFromVariant(0);  //command type is shutdown
								array.appendElement(variant, false);

								var win = ww.openWindow(null, "chrome://inbshutdown/content/Shutdown.xul",
														"Shutdown :: InBasic", "chrome,centerscreen", array);
							} 
						}
					};				  
					timer.initWithCallback(callback, 1000 * prefs.getCharPref("TimeBeforeStart"), Components.interfaces.nsITimer.TYPE_ONE_SHOT);
				}
				break;	
			}
	},
}

// constructors for objects we want to XPCOMify
var objects = [auto_shutdown_component];

/*
 * Registration code.
 *
 */

const CI = Components.interfaces, CC = Components.classes, CR = Components.results;

const MY_OBSERVER_NAME = "InBasic Autoshutdown - Component Observer";

function FactoryHolder(aObj) {
  this.CID        = aObj.prototype.classID;
  this.contractID = aObj.prototype.contractID;
  this.className  = aObj.prototype.classDescription;
  this.factory = {
    createInstance: function(aOuter, aIID) {
      if(aOuter)
        throw CR.NS_ERROR_NO_AGGREGATION;
      return (new this.constructor).QueryInterface(aIID);
    }
  };
  this.factory.constructor = aObj;
}

function SetDownloadCount(){
	var dlmgr = Components.classes['@mozilla.org/download-manager;1']
			.getService(Components.interfaces.nsIDownloadManager);    //**** Get Download file object

	var wm =Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var browserEnumerator = wm.getEnumerator("navigator:browser");
	while(browserEnumerator.hasMoreElements()){   //maybe more than 1 window opens!
		var dc = browserEnumerator.getNext().document;
		dc.getElementById('Sd.Status.Label').value = dlmgr.activeDownloadCount;
		dc.getElementById('Sd.Status.Label').hidden = 
			prefs.getBoolPref('StatusCounterHide') || (dlmgr.activeDownloadCount == 0);
	}
	return dlmgr.activeDownloadCount;
}


var gModule = {
  registerSelf: function (aComponentManager, aFileSpec, aLocation, aType)
  {
    aComponentManager.QueryInterface(CI.nsIComponentRegistrar);
    for (var key in this._objects) {
      var obj = this._objects[key];
      aComponentManager.registerFactoryLocation(obj.CID, obj.className,
        obj.contractID, aFileSpec, aLocation, aType);
    }

    // this can be deleted if you don't need to init on startup
    var catman = CC["@mozilla.org/categorymanager;1"].getService(CI.nsICategoryManager);
    catman.addCategoryEntry("xpcom-startup", MY_OBSERVER_NAME,
      auto_shutdown_component.prototype.contractID, true, true);
    catman.addCategoryEntry("xpcom-shutdown", MY_OBSERVER_NAME,
      auto_shutdown_component.prototype.contractID, true, true);
  },

  unregisterSelf: function(aCompMgr, aFileSpec, aLocation) {
    // this must be deleted if you delete the above code dealing with |catman|
    var catman = CC["@mozilla.org/categorymanager;1"].getService(CI.nsICategoryManager);
    catman.deleteCategoryEntry("xpcom-startup", MY_OBSERVER_NAME, true);
    // end of deleteable code

    aComponentManager.QueryInterface(CI.nsIComponentRegistrar);
    for (var key in this._objects) {
      var obj = this._objects[key];
      aComponentManager.unregisterFactoryLocation(obj.CID, aFileSpec);
    }
  },

  getClassObject: function(aComponentManager, aCID, aIID) {
    if (!aIID.equals(CI.nsIFactory)) throw CR.NS_ERROR_NOT_IMPLEMENTED;

    for (var key in this._objects) {
      if (aCID.equals(this._objects[key].CID))
        return this._objects[key].factory;
    }
   
    throw CR.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aComponentManager) {
    return true;
  },

  _objects: {} //FactoryHolder
};

function NSGetModule(compMgr, fileSpec)
{
  for(var i in objects)
    gModule._objects[i] = new FactoryHolder(objects[i]);
  return gModule;
} 
